		---------------------------------------------
		-- Paragon Reputation 1.10 by Sev-Drakkari --
		---------------------------------------------

		--[[	Special thanks to Ammako for
				helping me with the vars and
				the options.					]]--		

local vars = CreateFrame("FRAME") -- Variables
local reward = CreateFrame("FRAME")	-- RewardToast
local L = ParagonReputation; -- GetStrings
local toast = false; -- ActiveToastCheck
local rewardid = {
	[46777] = 2045, -- Armies of Legionfall
	[46745] = 1900, -- Court of Farondis
	[46747] = 1883, -- Dreamweavers
	[46743] = 1828, -- Highmountain Tribes
	[46748] = 1859, -- The Nightfallen
	[46749] = 1894, -- The Wardens
	[46746] = 1948  -- Valarjar
}

vars:RegisterEvent("ADDON_LOADED"); --RegisterAddonLoad
reward:RegisterEvent("QUEST_ACCEPTED") --RegisterQuestAccepted

-- Load Variables
vars:SetScript("OnEvent", function(self, event, arg1)
	if event == "ADDON_LOADED" and arg1 == "ParagonReputation" then
		if ParagonReputationDB == nil then
			ParagonReputationDB = {
				r = 0, g = .5, b = .9,
				bluecheck = true, greencheck = false, orangecheck = false, yellowcheck = false, redcheck = false,
				default = true, exalted = false, total = false, value = false, deficit = false,
				enable = false, sound = true,
				fade = 5
			}
		else
			if ParagonReputationDB.r == nil then ParagonReputationDB.r = 0 end
			if ParagonReputationDB.g == nil then ParagonReputationDB.g = .5 end
			if ParagonReputationDB.b == nil then ParagonReputationDB.b = .9 end
			if ParagonReputationDB.bluecheck == nil then ParagonReputationDB.bluecheck = true end
			if ParagonReputationDB.greencheck == nil then ParagonReputationDB.greencheck = false end
			if ParagonReputationDB.orangecheck == nil then ParagonReputationDB.orangecheck = false end
			if ParagonReputationDB.yellowcheck == nil then ParagonReputationDB.yellowcheck = false end
			if ParagonReputationDB.redcheck == nil then ParagonReputationDB.redcheck = false end
			if ParagonReputationDB.default == nil then ParagonReputationDB.default = true end
			if ParagonReputationDB.exalted == nil then ParagonReputationDB.exalted = false end
			if ParagonReputationDB.total == nil then ParagonReputationDB.total = false end
			if ParagonReputationDB.value == nil then ParagonReputationDB.value = false end
			if ParagonReputationDB.deficit == nil then ParagonReputationDB.deficit = false end
			if ParagonReputationDB.enable == nil then ParagonReputationDB.enable = false end
			if ParagonReputationDB.sound == nil then ParagonReputationDB.sound = true end
			if ParagonReputationDB.fade == nil then ParagonReputationDB.fade = 5 end
		end
		paragon_panel()
	end
end)

-- Options
function paragon_panel()
	local paragon_panel = CreateFrame("FRAME", "paragon_panel")
	paragon_panel.name = "Paragon Reputation"
	InterfaceOptions_AddCategory(paragon_panel)
	
	-- Title
	local title = paragon_panel:CreateFontString("Title", "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText("|cff0088eeParagon|r Reputation |cff0088eev1.10|r")

	-- Subtitle
	local subtitle = paragon_panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	subtitle:SetPoint('TOPLEFT', title, 'BOTTOMLEFT', 0, -8)
	subtitle:SetText(L["SETTINGS"])
	
	-- Color Label
	local labelcolor = paragon_panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	labelcolor:SetPoint('TOPLEFT', subtitle, 'BOTTOMLEFT', 0, -8)
	labelcolor:SetText(L["LABEL001"])

	-- Paragon Blue CheckBox
	local bluecheckbox = CreateFrame("CheckButton", "bluecheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	bluecheckbox:SetPoint('TOPLEFT', labelcolor, 'BOTTOMLEFT', -4, 0)
	bluecheckbox:SetWidth(30)
	bluecheckbox:SetHeight(30)
	_G[bluecheckbox:GetName().."Text"]:SetText("|cff0088ee"..L["BLUE"].."|r")
	bluecheckbox:SetChecked(ParagonReputationDB.bluecheck)
	bluecheckbox:SetScript("OnClick", function()
		bluecheckbox:SetChecked(true)
		greencheckbox:SetChecked(false)
		yellowcheckbox:SetChecked(false)
		orangecheckbox:SetChecked(false)
		redcheckbox:SetChecked(false)
		ParagonReputationDB.bluecheck = true
		ParagonReputationDB.greencheck = false
		ParagonReputationDB.yellowcheck = false
		ParagonReputationDB.orangecheck = false
		ParagonReputationDB.redcheck = false
		ParagonReputationDB.r = 0
		ParagonReputationDB.g = .5
		ParagonReputationDB.b = .9
	end)

	-- Default Green CheckBox
	local greencheckbox = CreateFrame("CheckButton", "greencheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	greencheckbox:SetPoint('TOPLEFT', labelcolor, 'BOTTOMLEFT', -4, -20)
	greencheckbox:SetWidth(30)
	greencheckbox:SetHeight(30)
	_G[greencheckbox:GetName().."Text"]:SetText("|cff009919"..L["GREEN"].."|r")
	greencheckbox:SetChecked(ParagonReputationDB.greencheck)
	greencheckbox:SetScript("OnClick", function()
		bluecheckbox:SetChecked(false)
		greencheckbox:SetChecked(true)
		yellowcheckbox:SetChecked(false)
		orangecheckbox:SetChecked(false)
		redcheckbox:SetChecked(false)
		ParagonReputationDB.bluecheck = false
		ParagonReputationDB.greencheck = true
		ParagonReputationDB.yellowcheck = false
		ParagonReputationDB.orangecheck = false
		ParagonReputationDB.redcheck = false		
		ParagonReputationDB.r = 0
		ParagonReputationDB.g = .6
		ParagonReputationDB.b = .1
	end)

	-- Neutral Yellow CheckBox
	local yellowcheckbox = CreateFrame("CheckButton", "yellowcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	yellowcheckbox:SetPoint('TOPLEFT', labelcolor, 'BOTTOMLEFT', -4, -40)
	yellowcheckbox:SetWidth(30)
	yellowcheckbox:SetHeight(30)
	_G[yellowcheckbox:GetName().."Text"]:SetText("|cffe6b200"..L["YELLOW"].."|r")
	yellowcheckbox:SetChecked(ParagonReputationDB.yellowcheck)
	yellowcheckbox:SetScript("OnClick", function()
		bluecheckbox:SetChecked(false)
		greencheckbox:SetChecked(false)
		yellowcheckbox:SetChecked(true)
		orangecheckbox:SetChecked(false)
		redcheckbox:SetChecked(false)
		ParagonReputationDB.bluecheck = false
		ParagonReputationDB.greencheck = false
		ParagonReputationDB.yellowcheck = true
		ParagonReputationDB.orangecheck = false
		ParagonReputationDB.redcheck = false		
		ParagonReputationDB.r = .9
		ParagonReputationDB.g = .7
		ParagonReputationDB.b = 0
	end)
	
	-- Unfriendly Orange CheckBox
	local orangecheckbox = CreateFrame("CheckButton", "orangecheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	orangecheckbox:SetPoint('TOPLEFT', labelcolor, 'BOTTOMLEFT', -4, -60)
	orangecheckbox:SetWidth(30)
	orangecheckbox:SetHeight(30)
	_G[orangecheckbox:GetName().."Text"]:SetText("|cffbf4500"..L["ORANGE"].."|r")
	orangecheckbox:SetChecked(ParagonReputationDB.orangecheck)
	orangecheckbox:SetScript("OnClick", function()
		bluecheckbox:SetChecked(false)
		greencheckbox:SetChecked(false)
		yellowcheckbox:SetChecked(false)
		orangecheckbox:SetChecked(true)
		redcheckbox:SetChecked(false)
		ParagonReputationDB.bluecheck = false
		ParagonReputationDB.greencheck = false
		ParagonReputationDB.yellowcheck = false
		ParagonReputationDB.orangecheck = true
		ParagonReputationDB.redcheck = false		
		ParagonReputationDB.r = .75
		ParagonReputationDB.g = .27
		ParagonReputationDB.b = 0
	end)
	
	-- Lightish Red CheckBox
	local redcheckbox = CreateFrame("CheckButton", "redcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	redcheckbox:SetPoint('TOPLEFT', labelcolor, 'BOTTOMLEFT', -4, -80)
	redcheckbox:SetWidth(30)
	redcheckbox:SetHeight(30)
	_G[redcheckbox:GetName().."Text"]:SetText("|cffff40a0"..L["RED"].."|r")
	redcheckbox:SetChecked(ParagonReputationDB.redcheck)
	redcheckbox:SetScript("OnClick", function()
		bluecheckbox:SetChecked(false)
		greencheckbox:SetChecked(false)
		yellowcheckbox:SetChecked(false)
		orangecheckbox:SetChecked(false)
		redcheckbox:SetChecked(true)
		ParagonReputationDB.bluecheck = false
		ParagonReputationDB.greencheck = false
		ParagonReputationDB.yellowcheck = false
		ParagonReputationDB.orangecheck = false
		ParagonReputationDB.redcheck = true		
		ParagonReputationDB.r = 1
		ParagonReputationDB.g = .25
		ParagonReputationDB.b = .62
	end)

	-- Text Format Label
	local labeltext = paragon_panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	labeltext:SetPoint('TOPLEFT', subtitle, 'BOTTOMLEFT', 208, -8)
	labeltext:SetText(L["LABEL002"])
	
	-- Paragon CheckBox
	local defaultcheckbox = CreateFrame("CheckButton", "defaultcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	defaultcheckbox:SetPoint('TOPLEFT', labeltext, 'BOTTOMLEFT', -4, 0)
	defaultcheckbox:SetWidth(30)
	defaultcheckbox:SetHeight(30)
	_G[defaultcheckbox:GetName().."Text"]:SetText(L["PARAGON"].." (0/10000)")
	defaultcheckbox:SetChecked(ParagonReputationDB.default)
	defaultcheckbox:SetScript("OnClick", function()
		defaultcheckbox:SetChecked(true)
		exaltedcheckbox:SetChecked(false)
		totalcheckbox:SetChecked(false)
		valuecheckbox:SetChecked(false)
		deficitcheckbox:SetChecked(false)
		ParagonReputationDB.default = true
		ParagonReputationDB.exalted = false
		ParagonReputationDB.total = false
		ParagonReputationDB.value = false
		ParagonReputationDB.deficit = false
	end)
	
	-- Exalted CheckBox
	local exaltedcheckbox = CreateFrame("CheckButton", "exaltedcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	exaltedcheckbox:SetPoint('TOPLEFT', labeltext, 'BOTTOMLEFT', -4, -20)
	exaltedcheckbox:SetWidth(30)
	exaltedcheckbox:SetHeight(30)
	_G[exaltedcheckbox:GetName().."Text"]:SetText(FACTION_STANDING_LABEL8.." (0/10000)")
	exaltedcheckbox:SetChecked(ParagonReputationDB.exalted)
	exaltedcheckbox:SetScript("OnClick", function()
		defaultcheckbox:SetChecked(false)
		exaltedcheckbox:SetChecked(true)
		totalcheckbox:SetChecked(false)
		valuecheckbox:SetChecked(false)
		deficitcheckbox:SetChecked(false)
		ParagonReputationDB.default = false
		ParagonReputationDB.exalted = true
		ParagonReputationDB.total = false
		ParagonReputationDB.value = false
		ParagonReputationDB.deficit = false
	end)
	
	-- 0 (0/10000) CheckBox
	local totalcheckbox = CreateFrame("CheckButton", "totalcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	totalcheckbox:SetPoint('TOPLEFT', labeltext, 'BOTTOMLEFT', -4, -40)
	totalcheckbox:SetWidth(30)
	totalcheckbox:SetHeight(30)
	_G[totalcheckbox:GetName().."Text"]:SetText("0 (0/10000)")
	totalcheckbox:SetChecked(ParagonReputationDB.total)
	totalcheckbox:SetScript("OnClick", function()
		defaultcheckbox:SetChecked(false)
		exaltedcheckbox:SetChecked(false)
		totalcheckbox:SetChecked(true)
		valuecheckbox:SetChecked(false)
		deficitcheckbox:SetChecked(false)
		ParagonReputationDB.default = false
		ParagonReputationDB.exalted = false
		ParagonReputationDB.total = true
		ParagonReputationDB.value = false
		ParagonReputationDB.deficit = false
	end)
	
	-- 0/10000 CheckBox
	local valuecheckbox = CreateFrame("CheckButton", "valuecheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	valuecheckbox:SetPoint('TOPLEFT', labeltext, 'BOTTOMLEFT', -4, -60)
	valuecheckbox:SetWidth(30)
	valuecheckbox:SetHeight(30)
	_G[valuecheckbox:GetName().."Text"]:SetText("0/10000")
	valuecheckbox:SetChecked(ParagonReputationDB.value)
	valuecheckbox:SetScript("OnClick", function()
		defaultcheckbox:SetChecked(false)
		exaltedcheckbox:SetChecked(false)
		totalcheckbox:SetChecked(false)
		valuecheckbox:SetChecked(true)
		deficitcheckbox:SetChecked(false)
		ParagonReputationDB.default = false
		ParagonReputationDB.exalted = false
		ParagonReputationDB.total = false
		ParagonReputationDB.value = true
		ParagonReputationDB.deficit = false
	end)
	
	-- Deficit CheckBox
	local deficitcheckbox = CreateFrame("CheckButton", "deficitcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	deficitcheckbox:SetPoint('TOPLEFT', labeltext, 'BOTTOMLEFT', -4, -80)
	deficitcheckbox:SetWidth(30)
	deficitcheckbox:SetHeight(30)
	_G[deficitcheckbox:GetName().."Text"]:SetText(L["DEFICIT"])
	deficitcheckbox:SetChecked(ParagonReputationDB.deficit)
	deficitcheckbox:SetScript("OnClick", function()
		defaultcheckbox:SetChecked(false)
		exaltedcheckbox:SetChecked(false)
		totalcheckbox:SetChecked(false)
		valuecheckbox:SetChecked(false)
		deficitcheckbox:SetChecked(true)
		ParagonReputationDB.default = false
		ParagonReputationDB.exalted = false
		ParagonReputationDB.total = false
		ParagonReputationDB.value = false
		ParagonReputationDB.deficit = true
	end)
	
	-- Toast Label
	local labeltoast = paragon_panel:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	labeltoast:SetPoint('TOPLEFT', subtitle, 'BOTTOMLEFT', 25, -138)
	labeltoast:SetText(L["LABEL003"])
	
	-- Toast Description
	local toastdesc = paragon_panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	toastdesc:SetPoint('TOPLEFT', labeltoast, 'BOTTOMLEFT', -23, -6)
	toastdesc:SetText(L["TOASTDESC"])
	
	-- Toast CheckBox
	local enablecheckbox = CreateFrame("CheckButton", "enablecheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	enablecheckbox:SetPoint('TOPLEFT', labeltoast, 'LEFT', -29, 15)
	enablecheckbox:SetWidth(30)
	enablecheckbox:SetHeight(30)
	enablecheckbox:SetChecked(ParagonReputationDB.enable)
	enablecheckbox:SetScript("OnClick", function()
		ParagonReputationDB.enable = enablecheckbox:GetChecked()
	end)
	
	-- Fade Selected Time
	local durationslider = paragon_panel:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	durationslider:SetPoint('TOPLEFT', toastdesc, 'BOTTOMLEFT', 70, -32)
	durationslider:SetText(ParagonReputationDB.fade.."s")
	
	-- Fade Timer Slider
	local fadeslider = CreateFrame("Slider", "fadeslider", paragon_panel, "OptionsSliderTemplate")
	fadeslider:ClearAllPoints()
	fadeslider:SetPoint('TOPLEFT', toastdesc, 'BOTTOMLEFT', 4, -17)
	fadeslider:SetMinMaxValues(2, 10)
	fadeslider:SetValue(ParagonReputationDB.fade)
	fadeslider:SetValueStep(1)
	fadeslider:SetObeyStepOnDrag(true)
	fadeslider:SetOrientation("HORIZONTAL")
	_G[fadeslider:GetName() .. "Low"]:SetText("2s")
	_G[fadeslider:GetName() .. "High"]:SetText("10s")
	_G[fadeslider:GetName() .. "Text"]:SetText(L["TOAST"])
	fadeslider:SetScript("OnValueChanged", function() 
		ParagonReputationDB.fade = fadeslider:GetValue()
		durationslider:SetText(fadeslider:GetValue().."s")		
	end)
	
	-- Sound CheckBox
	local soundcheckbox = CreateFrame("CheckButton", "soundcheckbox", paragon_panel, "ChatConfigCheckButtonTemplate")
	soundcheckbox:SetPoint('TOPLEFT', toastdesc, 'BOTTOMLEFT', -6, -42)
	soundcheckbox:SetWidth(30)
	soundcheckbox:SetHeight(30)
	_G[soundcheckbox:GetName().."Text"]:SetText(L["SOUND"])
	soundcheckbox:SetChecked(ParagonReputationDB.sound)
	soundcheckbox:SetScript("OnClick", function()
		ParagonReputationDB.sound = soundcheckbox:GetChecked()
	end)
end
	
-- Reward Toast
reward:SetScript("OnEvent",function(self,event,...)
	if ParagonReputationDB.enable == true then
		local _, _, _, _, _, _, _, questID = GetQuestLogTitle(...)
		if questID == 46777 or questID == 46745 or questID == 46747 or questID == 46743 or questID == 46748 or questID == 46749 or questID == 46746 then
			if toast == false then
				toast = true
				local name = GetFactionInfoByID(rewardid[questID])
				local questIndex = GetQuestLogIndexByID(questID);
				local text = GetQuestLogCompletionText(questIndex);
				local reset = ParagonReputationDB.fade + 1
				if ParagonReputationDB.sound == true then
					PlaySoundKitID(44295, "master", true)
				end
				local toastframe = CreateFrame("FRAME", "toastframe", UIParent)
				toastframe:SetPoint("TOP", UIParent, "TOP", 0, -64)
				toastframe:SetWidth(512)
				toastframe:SetHeight(128)
				local toasttexture = toastframe:CreateTexture(nil,"BACKGROUND")
				toasttexture:SetTexture("Interface\\AddOns\\ParagonReputation\\toast")
				toasttexture:SetAllPoints(toastframe)
				toastframe.texture = toasttexture
				local toasttitle = toastframe:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
				toasttitle:SetPoint('TOPLEFT', 128, -39)
				toasttitle:SetWidth(260)
				toasttitle:SetHeight(16)
				toasttitle:SetJustifyV("TOP")
				toasttitle:SetJustifyH("LEFT")
				toasttitle:SetText(name)
				local toasttext = toastframe:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
				toasttext:SetPoint('TOPLEFT', toasttitle, 1, -23)
				toasttext:SetWidth(258)
				toasttext:SetHeight(32)
				toasttext:SetJustifyV("TOP")
				toasttext:SetJustifyH("LEFT")
				toasttext:SetText(text)
				UIFrameFadeIn(toastframe, .5, 0, 1)
				UIFrameFadeIn(toasttext, 0, 0, 0)
				UIFrameFadeIn(toasttitle, 0, 0, 0)
				C_Timer.After(.5, function()
					UIFrameFadeIn(toasttitle, .5, 0, 1)
				end)
				C_Timer.After(.75, function()
					UIFrameFadeIn(toasttext, .5, 0, 1)
				end)
				C_Timer.After(ParagonReputationDB.fade, function()
					UIFrameFadeOut(toastframe, 1, 1, 0)
				end)
				C_Timer.After(reset, function()
					toast = false
				end)
			end
		end
	end
end)